import java.awt.datatransfer.DataFlavor;  
import java.awt.datatransfer.Transferable;  
import java.awt.datatransfer.UnsupportedFlavorException;  
import java.awt.dnd.DnDConstants;  
import java.awt.dnd.DropTarget;  
import java.awt.dnd.DropTargetDragEvent;  
import java.awt.dnd.DropTargetDropEvent;  
import java.awt.dnd.DropTargetEvent;  
import java.awt.dnd.DropTargetListener;  
import java.io.File;  
import java.io.IOException;  
import java.util.*;
import javax.swing.*;
import java.io.File;
import java.awt.BorderLayout;
import java.awt.event.*;

import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.UnsupportedFlavorException;

//String pastedMessage;
PImage pastedImage;
DropTarget dropTarget;
PImage output;

void setup() {  
  size(400, 300);

  dropTarget = new DropTarget(this, new DropTargetListener() {  
    public void dragEnter(DropTargetDragEvent dtde) {
    }  
    public void dragOver(DropTargetDragEvent dtde) {
    }  
    public void dropActionChanged(DropTargetDragEvent dtde) {
    }  
    public void dragExit(DropTargetEvent dte) {
    }  
    public void drop(DropTargetDropEvent dtde) {  
      dtde.acceptDrop(DnDConstants.ACTION_COPY_OR_MOVE);  
      Transferable trans = dtde.getTransferable();  
      List<File> fileNameList = null;  
      if (trans.isDataFlavorSupported(DataFlavor.javaFileListFlavor)) {  
        try {  
          fileNameList = (List<File>)  
            trans.getTransferData(DataFlavor.javaFileListFlavor);
        } 
        catch (UnsupportedFlavorException ex) {
        } 
        catch (IOException ex) {
        }
      }  
      if (fileNameList == null) return;  
      for (File f : fileNameList) {
        println(f.getAbsolutePath());
        String path = f.getAbsolutePath();
        PImage img = loadImage(path);        
        output = trimImage(img);
        changeWindowSize( output.width, output.height );        
        selectInput("Save image as...", "fileSelected");
      }
    }
  }
  );
}


void draw() {
  background(255);
  drawChessboard();
  if ( output != null ) {
    image( output, 0, 0 );
  }
}

void keyPressed() {
  if (key == 0x16) { // Ctrl+v
    // pastedMessage = GetTextFromClipboard();
    pastedImage = GetImageFromClipboard();
    if ( pastedImage != null ) {
      output = trimImage(pastedImage);
      changeWindowSize( output.width, output.height );        
      selectInput("Save image as...", "fileSelected");
    }
  }
}


void fileSelected(File selection) {
  if (selection == null) {
    // println("Window was closed or the user hit cancel.");
  } else {
    // println("User selected " + selection.getAbsolutePath());    
    String filename = selection.getAbsolutePath();
    File f = new File(filename);
    if ( f.exists() ) {
      String m = String.format("<html>%s already exists.<br>Do you want to replace it?", f.getAbsolutePath());
      int rv = JOptionPane.showConfirmDialog( this, m, "Save As", JOptionPane.YES_NO_OPTION);
      if ( rv == JOptionPane.NO_OPTION ) {
        return;
      }
    } 
    output.save(filename);
  }
}


PImage trimImage(PImage img) {
  img.loadPixels();
  color bg_color = img.pixels[0];  

  int top = -1;
  int bottom = 0;
  for (int y=0; y<img.height; y++) {
    for (int x=0; x<img.width; x++) {
      int i = y*img.width + x;
      if ( img.pixels[i] != bg_color ) {
        if ( top < 0 ) {
          top = y;
        }
        bottom = y;
        break;
      }
    }
  }

  int left = -1;
  int right = 0;
  for (int x=0; x<img.width; x++) {
    for (int y=0; y<img.height; y++) {
      int i = y*img.width + x;
      if ( img.pixels[i] != bg_color ) {
        if ( left < 0 ) {
          left = x;
        }
        right = x;
        break;
      }
    }
  }
  int w = right - left + 1;
  int h = bottom - top + 1;
  PImage out = new PImage(w, h, ARGB);

  out.loadPixels();
  for (int y=0; y<out.height; y++) {
    for (int x=0; x<out.width; x++) {      
      int i = y*out.width + x;
      int k = (y+top)*img.width + (x+left);

      if ( img.pixels[k] != bg_color ) {
        out.pixels[i] = img.pixels[k];
      } else {
        out.pixels[i] = color(255, 0, 0, 0);
      }
    }
  }

  out.updatePixels();
  return out;
}


void changeWindowSize(int w, int h) {
  frame.setSize( w + frame.getInsets().left + frame.getInsets().right, h + frame.getInsets().top + frame.getInsets().bottom );
  size(w, h);
}


void drawChessboard() {
  for (int y=0; y<height/10+1; y++) {
    for (int x=0; x<width/10+1; x++) {
      noStroke();
      if ( (x+y)%2==0 ) {
        fill(200);
      } else {
        fill(255);
      }
      rect( x*10, y*10, 10, 10 );
    }
  }
}

String GetTextFromClipboard() {
  String text = (String) GetFromClipboard(DataFlavor.stringFlavor);
  return text;
}

PImage GetImageFromClipboard() {
  PImage img = null;
  java.awt.Image image = (java.awt.Image) GetFromClipboard(DataFlavor.imageFlavor);  
  if (image != null) {
    try {
      img = new PImage(image);
    } 
    catch( Exception e ) {
    }
  }
  return img;
}

Object GetFromClipboard(DataFlavor flavor) {
  Clipboard clipboard = getToolkit().getSystemClipboard();
  Transferable contents = clipboard.getContents(null);
  Object obj = null;
  if (contents != null && contents.isDataFlavorSupported(flavor)) {
    try {
      obj = contents.getTransferData(flavor);
    }
    catch (UnsupportedFlavorException exu) { // Unlikely but we must catch it
      println("Unsupported flavor: " + exu);
      //~ exu.printStackTrace();
    }
    catch (java.io.IOException exi) {
      println("Unavailable data: " + exi);
      //~ exi.printStackTrace();
    }
  }
  return obj;
} 

